/*->c.cschoice */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "bbc.h"
#include "transform.h"
#include "xprocess.h"
#include "etc.h"


#include "wos.h"
#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "xmath.h"
#include "redraw.h"
#include "colour.h"
#include "drag.h"
#include "filetype.h"
#include "fsx.h"
#include "bf.h"
#include "bits.h"
#include "deb.h"


#include "dbhi.h"
#include "mhi.h"

#include "str.h"
#include "constants.h"

#include "reslink.h"
#include "units.h"
#include "posn.h"
#include "object.h"

#include "view.h"
#include "viewr.h"
#include "file.h"
#include "select.h"

#include "choices.h"
#include "dbchoices.h"
#include "dbmore.h"
#include "dbscale.h"


#include "xcolour.h"
#include "xxcolour.h"


#include "colsep.h"
#include "colseplink.h"



#include "colsepx.h"
#include "cscurve.h"
#include "csink.h"
#include "dbcolsep.h"
#include "csprint.h"
#include "icc.h"


#include "cschoice.h"



       int           csprintercolourmodel;
       int           csscreencolourmodel;

       int           cschoicebits;


static int xcolourmodel;

static int csink;
static int cscurve;
static int xcsink;
static int xcscurve;
static int xuseinks;


#define CSMODEOLD 0
#define CSMODEICC 1

static int xcsmode;


static int xxrgbprofile;
static int xxcmykprofile;
static int xxmonitorprofile;
static int xxprinterprofile;
static int xxsepsprofile;
static int xxmonitorintent;
static int xxprinterintent;
static int xxsepsintent;
static int xxmonitorflags;
static int xxprinterflags;


static int xrgbprofile;
static int xcmykprofile;
static int xmonitorprofile;
static int xprinterprofile;
static int xsepsprofile;
static int xmonitorintent;
static int xprinterintent;
static int xsepsintent;
static int xmonitorflags;
static int xprinterflags;


static int csrgbprofile;
static int cscmykprofile;
static int csmonitorprofile;
static int csprinterprofile;
static int cssepsprofile;
static int csmonitorintent;
static int csprinterintent;
static int cssepsintent;
static int csmonitorflags;
static int csprinterflags;



/* void cssetprofile(int n,int which) */

void cssetprofile(int fp)
{
 int      * stack;
 int        n;
 int        whichprofile;

 stack=xstackptr();
 n=stack[fp];
 whichprofile=stack[fp+1];

// if(n>=0 && n<cn) 
 {
  if(whichprofile==0)
  {
   xxrgbprofile=n;
   choicechangevalue(&xxrgbprofile);
  }
  else
  if(whichprofile==1)
  {
   xxcmykprofile=n;
   choicechangevalue(&xxcmykprofile);
  }
		else
  if(whichprofile==2)
  {
   xxmonitorprofile=n;
   choicechangevalue(&xxmonitorprofile);
  }
		else
  if(whichprofile==3)
  {
   xxprinterprofile=n;
   choicechangevalue(&xxprinterprofile);
  }
		else
  if(whichprofile==4)
  {
   xxsepsprofile=n;
   choicechangevalue(&xxsepsprofile);
  }


 }
}



/* int csgetprofile(int which) */

int csgetprofile(int fp)
{
 int      * stack;
 int        whichprofile;

 stack=xstackptr();
 whichprofile=stack[fp];

 if(whichprofile==0)
 {
  return(xxrgbprofile);
 }
 else
 if(whichprofile==1)
 {
  return(xxcmykprofile);
 }
 else
 if(whichprofile==2)
 {
  return(xxmonitorprofile);
 }
 else
 if(whichprofile==3)
 {
  return(xxprinterprofile);
 }
 else
 if(whichprofile==4)
 {
  return(xxsepsprofile);
 }

 return(0);

 USE(fp);
}






void cssetintent(int fp)
{
 int      * stack;
 int        n;
 int        whichprofile;

 stack=xstackptr();
 n=stack[fp];
 whichprofile=stack[fp+1];

// if(n>=0 && n<cn) 
 {
  if(whichprofile==2)
  {
   xxmonitorintent=n;
   choicechangevalue(&xxmonitorintent);
  }
		else
  if(whichprofile==3)
  {
   xxprinterintent=n;
   choicechangevalue(&xxprinterintent);
  }
		else
  if(whichprofile==4)
  {
   xxsepsintent=n;
   choicechangevalue(&xxsepsintent);
  }


 }
}



/* int csgetprofile(int which) */

int csgetintent(int fp)
{
 int      * stack;
 int        whichprofile;

 stack=xstackptr();
 whichprofile=stack[fp];

 if(whichprofile==2)
 {
  return(xxmonitorintent);
 }
 else
 if(whichprofile==3)
 {
  return(xxprinterintent);
 }
 else
 if(whichprofile==4)
 {
  return(xxsepsintent);
 }

 return(0);

 USE(fp);
}


/*******************************************************************************/



extern dboxstr csiccbox;




static os_error * csiccsetupclose(int code)
{
 os_error        * err;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  xrgbprofile=xxrgbprofile;
  xcmykprofile=xxcmykprofile;
  xmonitorprofile=xxmonitorprofile;
  xprinterprofile=xxprinterprofile;
  xsepsprofile=xxsepsprofile;
  xmonitorintent=xxmonitorintent;
  xprinterintent=xxprinterintent;
  xsepsintent=xxsepsintent;
  xmonitorflags=xxmonitorflags;
  xprinterflags=xxprinterflags;
 }

 return(err);
}









static os_error * icccmykcombo(int event,int data,void * datap,int * hit,uservalue * userp)
{
	os_error * err;

 err=menucombo(&csiccbox,26,"csprofilecmyk_menu",event,data,hit,userp);
																																																																																					 
	return(err);

	USE(datap);
}


static os_error * iccrgbcombo(int event,int data,void * datap,int * hit,uservalue * userp)
{
	os_error * err;

 err=menucombo(&csiccbox,25,"csprofilergb_menu",event,data,hit,userp);
																																																																																					 
	return(err);

	USE(datap);
}


static os_error * iccmonitorcombo(int event,int data,void * datap,int * hit,uservalue * userp)
{
	os_error * err;

 err=menucombo(&csiccbox,11,"csprofilemonitor_menu",event,data,hit,userp);
																																																																																					 
	return(err);

	USE(datap);
}



static os_error * iccmonitorintentcombo(int event,int data,void * datap,int * hit,uservalue * userp)
{
	os_error * err;

 err=menucombo(&csiccbox,10,"csmonitorintent_menu",event,data,hit,userp);
																																																																																					 
	return(err);

	USE(datap);
}





static os_error * iccprintercombo(int event,int data,void * datap,int * hit,uservalue * userp)
{
	os_error * err;

 err=menucombo(&csiccbox,21,"csprofileprinter_menu",event,data,hit,userp);
																																																																																					 
	return(err);

	USE(datap);
}


static os_error * iccprinterintentcombo(int event,int data,void * datap,int * hit,uservalue * userp)
{
	os_error * err;

 err=menucombo(&csiccbox,20,"csprinterintent_menu",event,data,hit,userp);
																																																																																					 
	return(err);

	USE(datap);
}




static os_error * iccsepscombo(int event,int data,void * datap,int * hit,uservalue * userp)
{
	os_error * err;

 err=menucombo(&csiccbox,24,"csprofileseps_menu",event,data,hit,userp);
																																																																																					 
	return(err);

	USE(datap);
}



static os_error * iccsepsintentcombo(int event,int data,void * datap,int * hit,uservalue * userp)
{
	os_error * err;

 err=menucombo(&csiccbox,23,"cssepsintent_menu",event,data,hit,userp);
																																																																																					 
	return(err);

	USE(datap);
}






static dbiconstr csiccicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */


    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,0,0,     NULL ,0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0 ,NULL ,0,



			11, &xxmonitorprofile,DBCOMBO,  1,   DBCOMBOSTATIC,      0,  0,  0,   0,  NULL,(dbwritefn)iccmonitorcombo,
			10,	&xxmonitorintent,DBCOMBO,  1,   DBCOMBOSTATIC,      0,  0,  0,   0,  NULL,(dbwritefn)iccmonitorintentcombo,
			13,	&xxmonitorflags, DBTOGGLE, 1,   0, CSMONITORSYSTEM,     0,  0,   0,  NULL, NULL,
			12,	&xxmonitorflags, DBTOGGLE, 1,   0, CSMONITORPROOF,     0,  0,   0,  NULL, NULL,


   26, &xxcmykprofile,DBCOMBO,  0,   DBCOMBOSTATIC,      0,  0,  0,   0,  NULL,(dbwritefn)icccmykcombo,
   25, &xxrgbprofile, DBCOMBO,  0,   DBCOMBOSTATIC,      0,  0,  0,   0,  NULL,(dbwritefn)iccrgbcombo,

   21, &xxprinterprofile, DBCOMBO,  1,   DBCOMBOSTATIC,      0,  0,  0,   0,  NULL,(dbwritefn)iccprintercombo,
			20, &xxprinterintent, DBCOMBO,  1,   DBCOMBOSTATIC,      0,  0,  0,   0,  NULL,(dbwritefn)iccprinterintentcombo,
			29,	&xxprinterflags, DBTOGGLE, 1,   0, CSPRINTERSYSTEM,   0,  0,   0,  NULL, NULL,

   24, &xxsepsprofile, DBCOMBO,  1,   DBCOMBOSTATIC,      0,  0,  0,   0,  NULL,(dbwritefn)iccsepscombo,
			23,	&xxsepsintent, DBCOMBO,  1,   DBCOMBOSTATIC,      0,  0,  0,   0,  NULL,(dbwritefn)iccsepsintentcombo,

   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};





static dboxstr csiccbox=
{
 0,
 TICCSETUP,
 DBFIX,
 0,
 csiccsetupclose,
 NULL,
 NULL,
 NULL,
 csiccicondefs,
 0,
 0,

 0,NULL,
 0,
 0,

};



static os_error * openiccsetup(dboxstr * parent)
{
	os_error * err;

 xxrgbprofile=xrgbprofile;
 xxcmykprofile=xcmykprofile;
 xxmonitorprofile=xmonitorprofile;
 xxprinterprofile=xprinterprofile;
 xxsepsprofile=xsepsprofile;
 xxmonitorintent=xmonitorintent;
 xxprinterintent=xprinterintent;
 xxsepsintent=xsepsintent;
 xxmonitorflags=xmonitorflags;
 xxprinterflags=xprinterflags;

	err=dodboxsp(&csiccbox,1,parent,getchoicestack());

 dbshade(1,DBSHADEG,&csiccbox);

	return(err);
}




/*******************************************************************************/


extern dboxstr cschoicebox;



static os_error * cswrcurvename(int value,char * string)
{
 strcpy(string,cs[value].title);
 return(NULL);
}



/* void cssetcurve(int n) */

void cssetcurve(int fp)
{
 int      * stack;
 int        n;

 stack=xstackptr();
 n=stack[fp];
 if(n>=0 && n<cn) 
 {
  xcscurve=n;
  choicechangevalue(&xcscurve);
 }
}



int csgetcurve(int fp)
{
 return(xcscurve);
 USE(fp);
}



/* void cssetink(int n) */

void cssetink(int fp)
{
 int      * stack;
 int        n;

 stack=xstackptr();
 n=stack[fp];
 if(n>=0 && n<csinkn) 
 {
  xcsink=n;
  choicechangevalue(&xcsink);
 }
}


int csgetink(int fp)
{
 return(xcsink);
 USE(fp);
}



static os_error * cswrinkname(int value,char * string)
{
 strcpy(string,csinknameptr(value));
 return(NULL);
}


static os_error * cswrrgbprofile(int value,char * string)
{
 strcpy(string,csprofilenameptr(value,0x1));
 return(NULL);
}


static os_error * cswrcmykprofile(int value,char * string)
{
 strcpy(string,csprofilenameptr(value,0x2));
 return(NULL);
}



static os_error * cschoiceicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 switch(m->i)
 {
  case  5:
          err=openmenuparent("cscurve_menu",handle);
          break;

  case  8:
          err=openmenuparent("csink_menu",handle);
          break;

  case 16:
          err=openiccsetup(getchoicedbox());
          break;


 }

 return(err);

 USE(handle);
 USE(userhandle);
}






static os_error * cschclose(int code)
{
 os_error * err;
 int        oldscreencolourmodel;
 int        oldprintercolourmodel;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  oldscreencolourmodel=csscreencolourmodel;
  oldprintercolourmodel=csprintercolourmodel;

  if(xcsmode==CSMODEICC)
  {
   csscreencolourmodel=CSSCREENPROFILE;
   csprintercolourmodel=CSPRINTERPROFILE;
  }
  else
  {
   csscreencolourmodel=xuseinks?CSINKMODEL:CSNAIVEMODEL;
   csprintercolourmodel=xcolourmodel;
  }

  if(csink!=xcsink || oldscreencolourmodel!=csscreencolourmodel ||
                      oldprintercolourmodel!=csprintercolourmodel ||
     csrgbprofile!=xrgbprofile || cscmykprofile!=xcmykprofile
 
    )
  {
   choicechange(CHOICEVIEW);
		}

  /* last clause is for sep views only */

  cscurve=xcscurve;
  err=cssetcurvex(cscurve);
  if(!err)
  {
   csink=xcsink;
   err=cssetinkx(csink);
  }

  if(!err)
  {
            err=cssetprofiles(xrgbprofile,xcmykprofile,xmonitorprofile,xprinterprofile);
			if(!err) err=cssetprofiles2(xsepsprofile);
			if(!err) err=cssetprofiles3(xmonitorintent,xmonitorflags,xprinterintent,xprinterflags,xsepsintent);
   if(!err)
   {
    csrgbprofile=xrgbprofile;
    cscmykprofile=xcmykprofile;
    csmonitorprofile=xmonitorprofile;
    csprinterprofile=xprinterprofile;
    cssepsprofile=xsepsprofile;
    csmonitorintent=xmonitorintent;
    csprinterintent=xprinterintent;
    cssepsintent=xsepsintent;
    csmonitorflags=xmonitorflags;
    csprinterflags=xprinterflags;

    if(oldscreencolourmodel!=csscreencolourmodel || oldprintercolourmodel!=csprintercolourmodel)
				{
				 event(EVENT_NEWCOLOURMODEL,NULL,0);
				}
   }
  }
 }

// cprintf("screen %d printer %d",csscreencolourmodel,csprintercolourmodel);

 return(err);
}


static os_error * cschsave(buffer * bfx)
{
 os_error * err;
 buffer     bf;
 char       cschoicepath[MAX_PATH];

 err=NULL;

 if(getmultiuser())
 {
  xzstrncpy(cschoicepath,colseppath,sizeof(cschoicepath));
  strcat(cschoicepath,"\\Colsupp\\AutoRun\\!Choices.csc");
  err=fs_validatepath(cschoicepath,0);
 }
 else
 {
  xzstrncpy(cschoicepath,colsepbasepath,sizeof(cschoicepath));
  strcat(cschoicepath,"\\Colsupp\\AutoRun\\!Choices.csc");
 }


 if(!err) err=bf_open(cschoicepath,'w',0x200,&bf);
 if(!err)
 {
  err=bf_printfeol(&bf,"void main(void)\r\n{\r\ncschoices(\"%s\",\"%s\",%d,%d);",
                  cs[cscurve].title,
                  csinknameptr(csink),
                  csprintercolourmodel,
                  csscreencolourmodel);

  if(!err) err=csprintchoices(&bf);

  if(!err) err=bf_printfeol(&bf,"cschoices4(%d,%d,%d,%d);",cschoicebits,0,0,0);

  if(!err) err=bf_printfeol(&bf,"cschoices5(\"%s\",\"%s\",\"%s\",\"%s\");",csprofilenameptr(csrgbprofile,0x1),csprofilenameptr(cscmykprofile,0x2),csprofilenameptr(csmonitorprofile,0x1),csprofilenameptr(csprinterprofile,0x1));

  if(!err) err=bf_printfeol(&bf,"cschoices5(\"%s\",\"%s\",\"\",\"\");",csprofilenameptr(csrgbprofile,0x1),csprofilenameptr(cscmykprofile,0x2));


  if(!err) err=bf_printfeol(&bf,"cschoices6(\"%s\",\"\",\"\",\"\");",csprofilenameptr(cssepsprofile,0x2),"","","");

  if(!err) err=bf_printfeol(&bf,"cschoices7(%d,%d,%d,%d,%d,0);",csmonitorintent,csmonitorflags,csprinterintent,csprinterflags,cssepsintent);

  
  if(!err) err=bf_printf(&bf,"\r\n}\r\n");

  err=bf_closec(&bf,err,cschoicepath,SCRIPT2);
 }

 return(err);
 USE(bfx);
}




void cschoices(int fp)
{
 os_error * err;
 int      * stack;

 stack=xstackptr();

 cscurve=csfindcurvename(stringptr(stack[fp+0]));
 if(cscurve<0) cscurve=0;

 csink=csfindinkname(stringptr(stack[fp+1]));
 if(csink<0) csink=0;

          err=cssetcurvex(cscurve);
 if(!err) err=cssetinkx(csink);

 csprintercolourmodel=stack[fp+2];

 csscreencolourmodel=stack[fp+3];

	if(!csprofilesactive())
	{
		if(csprintercolourmodel==CSPRINTERPROFILE) csprintercolourmodel=CSNAIVEMODEL;
		if(csscreencolourmodel==CSSCREENPROFILE) csscreencolourmodel=CSNAIVEMODEL;
	}

 zreport(err);
}


int cschoices4(int fp)
{
 int * stack;

 stack=xstackptr();

 cschoicebits&=~stack[fp+1];
 cschoicebits|=stack[fp];

 return(cschoicebits);
}


void cschoices5(int fp)
{
 int * stack;

 stack=xstackptr();

 csrgbprofile=csfindprofile(stringptr(stack[fp+0]),0x1);
 cscmykprofile=csfindprofile(stringptr(stack[fp+1]),0x2);
	csmonitorprofile=csfindprofile(stringptr(stack[fp+2]),0x1);
	csprinterprofile=csfindprofile(stringptr(stack[fp+3]),0x1);

 zreport(cssetprofiles(csrgbprofile,cscmykprofile,csmonitorprofile,csprinterprofile));
}


void cschoices6(int fp)
{
 int * stack;

 stack=xstackptr();

 cssepsprofile=csfindprofile(stringptr(stack[fp+0]),0x2);

 zreport(cssetprofiles2(cssepsprofile));
}

void cschoices7(int fp)
{
 int * stack;

 stack=xstackptr();

	csmonitorintent=stack[fp+0];
	csmonitorflags=stack[fp+1];
	csprinterintent=stack[fp+2];
	csprinterflags=stack[fp+3];
	cssepsintent=stack[fp+4];

	zreport(cssetprofiles3(csmonitorintent,csmonitorflags,csprinterintent,csprinterflags,cssepsintent));
}





char * cscinkname(void)
{
 return(csinknameptr(csink));
}


char * csccurvename(void)
{
 return(cs[cscurve].title);
}


char * csprinterprofilename(void)
{
 return(csprofilenameptr(cscmykprofile,0x2));
}


char * csscreenprofilename(void)
{
 return(csprofilenameptr(cscmykprofile,0x2));
}






static os_error * optfn(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 dboxstr  * dbox;

 err=NULL;

 dbox=choicepanedbox();

 dbshade(1,(xcsmode==CSMODEICC)?DBSHADEG:0,dbox);
 shadeiconst(dbox->handle,5,xcsmode==CSMODEICC);
 shadeiconst(dbox->handle,8,xcsmode==CSMODEICC);

 dbshade(2,(xcsmode==CSMODEOLD)?DBSHADEG:0,dbox);
 shadeiconst(dbox->handle,16,xcsmode==CSMODEOLD);
 shadeiconst(dbox->handle,19,xcsmode==CSMODEOLD);

 return(err);
}



static dbiconstr cschoiceicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

   12, &xcolourmodel,DBTOGGLE,  1,   0, CSCURVEMODEL,F2, 0, 0,    NULL ,0,
//    6, &xcolourmodel,DBRADIO, 0,   0, CSINKMODEL,  F3, 0, 0,    NULL ,0,
//   22, &xcolourmodel,DBRADIO, 0,   0, CSNAIVEMODEL,F4, 0, 0,    NULL ,0,

    4, &xcscurve,     DBTEXT,   1,   0,      0,  0,  0,  0, NULL,cswrcurvename,
    7, &xcsink,       DBTEXT,   1,   0,      0,  0,  0,  0, NULL,cswrinkname,

    9, &xuseinks,     DBTOGGLE, 1,   0,      1,  F2, 0, 0,  NULL,    0,

  100, &xcsmode,      DBRADIO, 0,   0, CSMODEOLD,  F3, 0, 0,(dbreadfn)optfn,0,
  101, &xcsmode,      DBRADIO, 0,   0, CSMODEICC,  F3, 0, 0,(dbreadfn)optfn,0,

/*
  15,  &xrgbprofile,  DBTEXT,   2,   0,      0,  0,  0,  0, NULL,cswrrgbprofile,
  18,  &xcmykprofile, DBTEXT,   2,   0,      0,  0,  0,  0, NULL,cswrcmykprofile,
*/

   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};




static os_error * cschpane(int select)
{
 os_error * err;
 dboxstr  * dbox;

 err=NULL;

 if(select==2)
 {
  dbox=choicepanedbox();

  dbshade(1,(xcsmode==CSMODEICC)?DBSHADEG:0,dbox);
  shadeiconst(dbox->handle,5,xcsmode==CSMODEICC);
  shadeiconst(dbox->handle,8,xcsmode==CSMODEICC);

  dbshade(2,(xcsmode==CSMODEOLD)?DBSHADEG:0,dbox);
  shadeiconst(dbox->handle,16,xcsmode==CSMODEOLD);
  shadeiconst(dbox->handle,19,xcsmode==CSMODEOLD);

  shadeiconst(dbox->handle,101,!csprofilesactive());		

 }

 return(err);
}



static os_error * cschopen(void)
{
 xcolourmodel=(csprintercolourmodel==CSCURVEMODEL);
 xuseinks=(csscreencolourmodel==CSINKMODEL);
 xcscurve=cscurve;
 xcsink=csink;
 xrgbprofile=csrgbprofile;
 xcmykprofile=cscmykprofile;
 if((csscreencolourmodel==CSSCREENPROFILE) || (csprintercolourmodel==CSPRINTERPROFILE)) xcsmode=CSMODEICC;
 else                                                                                   xcsmode=CSMODEOLD;

 cprintf("screen %d printer %d",csscreencolourmodel,csprintercolourmodel);

 return(NULL);
}


static dboxstr cschoicebox=
{
 0,
 TCSCHOICE,
 DBPANE,
 0,
 NULL,
 cschoiceicon,
 NULL,
 NULL,
 cschoiceicondefs,
 0,
 0,

 0,NULL,
 0,
 0,

};


static subchoicestr cschoice=
{
 NULL,

 &cschoicebox,

 "ch_colour",
 "{CSCH}",

 cschsave,
 cschclose,
 cschpane,
 cschopen,
};


os_error * cschoiceinit(void)
{
 return(choicesadd(&cschoice));
}


